<template lang="pug">
	button(type="checkbox" :title="title" :class="{ checked:internal_checked }" @click="toggle_value")
		i {{ internal_checked ? 'check_box' : 'check_box_outline_blank' }}
</template>

<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
	props: {
		title: {
			type: String,
			default: null,
			required: false,
		},
		checked: {
			type: Boolean,
			default: false,
			required: false,
		},
		onchange: {
			type: Function,
			default: null,
			required: false,
		},
	},
	data() {
		return {
			internal_checked: this.checked,
		};
	},
	methods: {
		get_value() {
			return this.internal_checked;
		},
		toggle_value() {
			this.internal_checked = this.internal_checked ? false : true;
			if (this.onchange) {
				this.onchange(this.internal_checked);
			}
		},
	},
});
</script>

<style lang="scss" scoped>
@import "@/assets/style/_colors.scss";
@import "@/assets/style/_dimensions.scss";

button {
	display: inline-block;

	-webkit-appearance: none;
	-moz-appearance: none;
	appearance: none;
	margin: 2px;
	border: none;
	height: 36px;
	width: 36px;
	-moz-outline: none;
	outline: none;
	color: $accent-bg-color;
	transition: all 200ms linear;
	&:hover {
		cursor: pointer;
		color: $accent-bg-color-hover;
	}
	&:active, &.checked {
		color: $accent-bg-color-active;
	}
	&::-moz-focus-inner {
		border: 0;
	}
}

i {
	font-family: 'Material Icons';
	font-weight: normal;
	font-style: normal;
	font-size: 36px;  /* Preferred icon size */
	display: inline-block;
	line-height: 36px;
	width: 100%;
	max-width: 100%;
	text-transform: none;
	letter-spacing: normal;
	word-wrap: normal;
	white-space: nowrap;
	direction: ltr;

	/* Support for all WebKit browsers. */
	-webkit-font-smoothing: antialiased;
	/* Support for Safari and Chrome. */
	text-rendering: optimizeLegibility;

	/* Support for Firefox. */
	-moz-osx-font-smoothing: grayscale;

	/* Support for IE. */
	font-feature-settings: 'liga';
}
</style>
